#!/bin/sh
# This shell script is run before Openbox launches.
# Environment variables set here are passed to the Openbox session.

# D-bus session
if which dbus-launch >/dev/null && test -z "$DBUS_SESSION_BUS_ADDRESS"; then
       eval `dbus-launch --sh-syntax --exit-with-session`
fi

#application paramètres résolution/écrans ; apply screen and resolution parameters
~/.screenlayout/*.sh

## Desktop environment

#suspend to ram quand on arrive à 3% de batterie ; suspend to ram when 3% battery capacity left
~/.autosuspend &

#jolis fondus et transparence ; nice fadings and transparency
#xcompmgr -CfF &

#panel
fbpanel &

#un fond d'écran pris au hasard dans ~/Fonds, également mis au bureau pcmanfm
#a wallpaper taken randomly in ~/Fonds, also applied to pcmanfm's desktop
(imgfond="$(find ~/Fonds -type f |sort -R |tail -1)";feh --bg-scale $imgfond;sed -i "s|^wallpaper=.*$|wallpaper=$imgfond|" ~/.config/pcmanfm/pcmanfm.conf) &

#icônes du bureau ; desktop icons
#pcmanfm --desktop &

#on éteint l'écran après 10mn d'inactivité ; screen goes off after 10mn of inactivity
xset dpms 0 0 600 &

#moniteur de batterie en tray ; battery monitor in the tray
#BatterySystemTray &

#réglage du volume sonore en tray ; sound volume control in the tray
#volumeicon &

#addons
(while [ -z "$(pidof openbox)" ];do sleep 1;done && for addon in /addons/xsession/*;do ($addon &);done) &
